// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/ent/predicate"
	"github.com/direktiv/direktiv/ent/workflowevents"
	"github.com/direktiv/direktiv/ent/workfloweventswait"
)

// WorkflowEventsWaitQuery is the builder for querying WorkflowEventsWait entities.
type WorkflowEventsWaitQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.WorkflowEventsWait
	// eager-loading edges.
	withWorkflowevent *WorkflowEventsQuery
	withFKs           bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the WorkflowEventsWaitQuery builder.
func (wewq *WorkflowEventsWaitQuery) Where(ps ...predicate.WorkflowEventsWait) *WorkflowEventsWaitQuery {
	wewq.predicates = append(wewq.predicates, ps...)
	return wewq
}

// Limit adds a limit step to the query.
func (wewq *WorkflowEventsWaitQuery) Limit(limit int) *WorkflowEventsWaitQuery {
	wewq.limit = &limit
	return wewq
}

// Offset adds an offset step to the query.
func (wewq *WorkflowEventsWaitQuery) Offset(offset int) *WorkflowEventsWaitQuery {
	wewq.offset = &offset
	return wewq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (wewq *WorkflowEventsWaitQuery) Unique(unique bool) *WorkflowEventsWaitQuery {
	wewq.unique = &unique
	return wewq
}

// Order adds an order step to the query.
func (wewq *WorkflowEventsWaitQuery) Order(o ...OrderFunc) *WorkflowEventsWaitQuery {
	wewq.order = append(wewq.order, o...)
	return wewq
}

// QueryWorkflowevent chains the current query on the "workflowevent" edge.
func (wewq *WorkflowEventsWaitQuery) QueryWorkflowevent() *WorkflowEventsQuery {
	query := &WorkflowEventsQuery{config: wewq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := wewq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := wewq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(workfloweventswait.Table, workfloweventswait.FieldID, selector),
			sqlgraph.To(workflowevents.Table, workflowevents.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, workfloweventswait.WorkfloweventTable, workfloweventswait.WorkfloweventColumn),
		)
		fromU = sqlgraph.SetNeighbors(wewq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first WorkflowEventsWait entity from the query.
// Returns a *NotFoundError when no WorkflowEventsWait was found.
func (wewq *WorkflowEventsWaitQuery) First(ctx context.Context) (*WorkflowEventsWait, error) {
	nodes, err := wewq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{workfloweventswait.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) FirstX(ctx context.Context) *WorkflowEventsWait {
	node, err := wewq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first WorkflowEventsWait ID from the query.
// Returns a *NotFoundError when no WorkflowEventsWait ID was found.
func (wewq *WorkflowEventsWaitQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = wewq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{workfloweventswait.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) FirstIDX(ctx context.Context) int {
	id, err := wewq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single WorkflowEventsWait entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one WorkflowEventsWait entity is not found.
// Returns a *NotFoundError when no WorkflowEventsWait entities are found.
func (wewq *WorkflowEventsWaitQuery) Only(ctx context.Context) (*WorkflowEventsWait, error) {
	nodes, err := wewq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{workfloweventswait.Label}
	default:
		return nil, &NotSingularError{workfloweventswait.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) OnlyX(ctx context.Context) *WorkflowEventsWait {
	node, err := wewq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only WorkflowEventsWait ID in the query.
// Returns a *NotSingularError when exactly one WorkflowEventsWait ID is not found.
// Returns a *NotFoundError when no entities are found.
func (wewq *WorkflowEventsWaitQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = wewq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = &NotSingularError{workfloweventswait.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) OnlyIDX(ctx context.Context) int {
	id, err := wewq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of WorkflowEventsWaits.
func (wewq *WorkflowEventsWaitQuery) All(ctx context.Context) ([]*WorkflowEventsWait, error) {
	if err := wewq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return wewq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) AllX(ctx context.Context) []*WorkflowEventsWait {
	nodes, err := wewq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of WorkflowEventsWait IDs.
func (wewq *WorkflowEventsWaitQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := wewq.Select(workfloweventswait.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) IDsX(ctx context.Context) []int {
	ids, err := wewq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (wewq *WorkflowEventsWaitQuery) Count(ctx context.Context) (int, error) {
	if err := wewq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return wewq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) CountX(ctx context.Context) int {
	count, err := wewq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (wewq *WorkflowEventsWaitQuery) Exist(ctx context.Context) (bool, error) {
	if err := wewq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return wewq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (wewq *WorkflowEventsWaitQuery) ExistX(ctx context.Context) bool {
	exist, err := wewq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the WorkflowEventsWaitQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (wewq *WorkflowEventsWaitQuery) Clone() *WorkflowEventsWaitQuery {
	if wewq == nil {
		return nil
	}
	return &WorkflowEventsWaitQuery{
		config:            wewq.config,
		limit:             wewq.limit,
		offset:            wewq.offset,
		order:             append([]OrderFunc{}, wewq.order...),
		predicates:        append([]predicate.WorkflowEventsWait{}, wewq.predicates...),
		withWorkflowevent: wewq.withWorkflowevent.Clone(),
		// clone intermediate query.
		sql:  wewq.sql.Clone(),
		path: wewq.path,
	}
}

// WithWorkflowevent tells the query-builder to eager-load the nodes that are connected to
// the "workflowevent" edge. The optional arguments are used to configure the query builder of the edge.
func (wewq *WorkflowEventsWaitQuery) WithWorkflowevent(opts ...func(*WorkflowEventsQuery)) *WorkflowEventsWaitQuery {
	query := &WorkflowEventsQuery{config: wewq.config}
	for _, opt := range opts {
		opt(query)
	}
	wewq.withWorkflowevent = query
	return wewq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Events map[string]interface {} `json:"events,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.WorkflowEventsWait.Query().
//		GroupBy(workfloweventswait.FieldEvents).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (wewq *WorkflowEventsWaitQuery) GroupBy(field string, fields ...string) *WorkflowEventsWaitGroupBy {
	group := &WorkflowEventsWaitGroupBy{config: wewq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := wewq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return wewq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Events map[string]interface {} `json:"events,omitempty"`
//	}
//
//	client.WorkflowEventsWait.Query().
//		Select(workfloweventswait.FieldEvents).
//		Scan(ctx, &v)
//
func (wewq *WorkflowEventsWaitQuery) Select(fields ...string) *WorkflowEventsWaitSelect {
	wewq.fields = append(wewq.fields, fields...)
	return &WorkflowEventsWaitSelect{WorkflowEventsWaitQuery: wewq}
}

func (wewq *WorkflowEventsWaitQuery) prepareQuery(ctx context.Context) error {
	for _, f := range wewq.fields {
		if !workfloweventswait.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if wewq.path != nil {
		prev, err := wewq.path(ctx)
		if err != nil {
			return err
		}
		wewq.sql = prev
	}
	return nil
}

func (wewq *WorkflowEventsWaitQuery) sqlAll(ctx context.Context) ([]*WorkflowEventsWait, error) {
	var (
		nodes       = []*WorkflowEventsWait{}
		withFKs     = wewq.withFKs
		_spec       = wewq.querySpec()
		loadedTypes = [1]bool{
			wewq.withWorkflowevent != nil,
		}
	)
	if wewq.withWorkflowevent != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, workfloweventswait.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &WorkflowEventsWait{config: wewq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, wewq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := wewq.withWorkflowevent; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*WorkflowEventsWait)
		for i := range nodes {
			if nodes[i].workflow_events_wfeventswait == nil {
				continue
			}
			fk := *nodes[i].workflow_events_wfeventswait
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(workflowevents.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "workflow_events_wfeventswait" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Workflowevent = n
			}
		}
	}

	return nodes, nil
}

func (wewq *WorkflowEventsWaitQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := wewq.querySpec()
	return sqlgraph.CountNodes(ctx, wewq.driver, _spec)
}

func (wewq *WorkflowEventsWaitQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := wewq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (wewq *WorkflowEventsWaitQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   workfloweventswait.Table,
			Columns: workfloweventswait.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: workfloweventswait.FieldID,
			},
		},
		From:   wewq.sql,
		Unique: true,
	}
	if unique := wewq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := wewq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, workfloweventswait.FieldID)
		for i := range fields {
			if fields[i] != workfloweventswait.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := wewq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := wewq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := wewq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := wewq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (wewq *WorkflowEventsWaitQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(wewq.driver.Dialect())
	t1 := builder.Table(workfloweventswait.Table)
	columns := wewq.fields
	if len(columns) == 0 {
		columns = workfloweventswait.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if wewq.sql != nil {
		selector = wewq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range wewq.predicates {
		p(selector)
	}
	for _, p := range wewq.order {
		p(selector)
	}
	if offset := wewq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := wewq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// WorkflowEventsWaitGroupBy is the group-by builder for WorkflowEventsWait entities.
type WorkflowEventsWaitGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (wewgb *WorkflowEventsWaitGroupBy) Aggregate(fns ...AggregateFunc) *WorkflowEventsWaitGroupBy {
	wewgb.fns = append(wewgb.fns, fns...)
	return wewgb
}

// Scan applies the group-by query and scans the result into the given value.
func (wewgb *WorkflowEventsWaitGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := wewgb.path(ctx)
	if err != nil {
		return err
	}
	wewgb.sql = query
	return wewgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := wewgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(wewgb.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := wewgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) StringsX(ctx context.Context) []string {
	v, err := wewgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = wewgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) StringX(ctx context.Context) string {
	v, err := wewgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(wewgb.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := wewgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) IntsX(ctx context.Context) []int {
	v, err := wewgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = wewgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) IntX(ctx context.Context) int {
	v, err := wewgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(wewgb.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := wewgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := wewgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = wewgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) Float64X(ctx context.Context) float64 {
	v, err := wewgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(wewgb.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := wewgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := wewgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (wewgb *WorkflowEventsWaitGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = wewgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (wewgb *WorkflowEventsWaitGroupBy) BoolX(ctx context.Context) bool {
	v, err := wewgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (wewgb *WorkflowEventsWaitGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range wewgb.fields {
		if !workfloweventswait.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := wewgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := wewgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (wewgb *WorkflowEventsWaitGroupBy) sqlQuery() *sql.Selector {
	selector := wewgb.sql.Select()
	aggregation := make([]string, 0, len(wewgb.fns))
	for _, fn := range wewgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(wewgb.fields)+len(wewgb.fns))
		for _, f := range wewgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(wewgb.fields...)...)
}

// WorkflowEventsWaitSelect is the builder for selecting fields of WorkflowEventsWait entities.
type WorkflowEventsWaitSelect struct {
	*WorkflowEventsWaitQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (wews *WorkflowEventsWaitSelect) Scan(ctx context.Context, v interface{}) error {
	if err := wews.prepareQuery(ctx); err != nil {
		return err
	}
	wews.sql = wews.WorkflowEventsWaitQuery.sqlQuery(ctx)
	return wews.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) ScanX(ctx context.Context, v interface{}) {
	if err := wews.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Strings(ctx context.Context) ([]string, error) {
	if len(wews.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := wews.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) StringsX(ctx context.Context) []string {
	v, err := wews.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = wews.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) StringX(ctx context.Context) string {
	v, err := wews.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Ints(ctx context.Context) ([]int, error) {
	if len(wews.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := wews.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) IntsX(ctx context.Context) []int {
	v, err := wews.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = wews.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) IntX(ctx context.Context) int {
	v, err := wews.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(wews.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := wews.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) Float64sX(ctx context.Context) []float64 {
	v, err := wews.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = wews.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) Float64X(ctx context.Context) float64 {
	v, err := wews.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(wews.fields) > 1 {
		return nil, errors.New("ent: WorkflowEventsWaitSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := wews.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) BoolsX(ctx context.Context) []bool {
	v, err := wews.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (wews *WorkflowEventsWaitSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = wews.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{workfloweventswait.Label}
	default:
		err = fmt.Errorf("ent: WorkflowEventsWaitSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (wews *WorkflowEventsWaitSelect) BoolX(ctx context.Context) bool {
	v, err := wews.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (wews *WorkflowEventsWaitSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := wews.sql.Query()
	if err := wews.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
