// Code generated by go-swagger; DO NOT EDIT.

package namespace_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteNamespaceRevisionParams creates a new DeleteNamespaceRevisionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteNamespaceRevisionParams() *DeleteNamespaceRevisionParams {
	return &DeleteNamespaceRevisionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteNamespaceRevisionParamsWithTimeout creates a new DeleteNamespaceRevisionParams object
// with the ability to set a timeout on a request.
func NewDeleteNamespaceRevisionParamsWithTimeout(timeout time.Duration) *DeleteNamespaceRevisionParams {
	return &DeleteNamespaceRevisionParams{
		timeout: timeout,
	}
}

// NewDeleteNamespaceRevisionParamsWithContext creates a new DeleteNamespaceRevisionParams object
// with the ability to set a context for a request.
func NewDeleteNamespaceRevisionParamsWithContext(ctx context.Context) *DeleteNamespaceRevisionParams {
	return &DeleteNamespaceRevisionParams{
		Context: ctx,
	}
}

// NewDeleteNamespaceRevisionParamsWithHTTPClient creates a new DeleteNamespaceRevisionParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteNamespaceRevisionParamsWithHTTPClient(client *http.Client) *DeleteNamespaceRevisionParams {
	return &DeleteNamespaceRevisionParams{
		HTTPClient: client,
	}
}

/* DeleteNamespaceRevisionParams contains all the parameters to send to the API endpoint
   for the delete namespace revision operation.

   Typically these are written to a http.Request.
*/
type DeleteNamespaceRevisionParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* RevisionGeneration.

	   target revision generation
	*/
	RevisionGeneration string

	/* ServiceName.

	   target service name
	*/
	ServiceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete namespace revision params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceRevisionParams) WithDefaults() *DeleteNamespaceRevisionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete namespace revision params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNamespaceRevisionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithTimeout(timeout time.Duration) *DeleteNamespaceRevisionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithContext(ctx context.Context) *DeleteNamespaceRevisionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithHTTPClient(client *http.Client) *DeleteNamespaceRevisionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithNamespace(namespace string) *DeleteNamespaceRevisionParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithRevisionGeneration adds the revisionGeneration to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithRevisionGeneration(revisionGeneration string) *DeleteNamespaceRevisionParams {
	o.SetRevisionGeneration(revisionGeneration)
	return o
}

// SetRevisionGeneration adds the revisionGeneration to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetRevisionGeneration(revisionGeneration string) {
	o.RevisionGeneration = revisionGeneration
}

// WithServiceName adds the serviceName to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) WithServiceName(serviceName string) *DeleteNamespaceRevisionParams {
	o.SetServiceName(serviceName)
	return o
}

// SetServiceName adds the serviceName to the delete namespace revision params
func (o *DeleteNamespaceRevisionParams) SetServiceName(serviceName string) {
	o.ServiceName = serviceName
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteNamespaceRevisionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param revisionGeneration
	if err := r.SetPathParam("revisionGeneration", o.RevisionGeneration); err != nil {
		return err
	}

	// path param serviceName
	if err := r.SetPathParam("serviceName", o.ServiceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
