// Code generated by go-swagger; DO NOT EDIT.

package registries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteGlobalPrivateRegistryParams creates a new DeleteGlobalPrivateRegistryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteGlobalPrivateRegistryParams() *DeleteGlobalPrivateRegistryParams {
	return &DeleteGlobalPrivateRegistryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteGlobalPrivateRegistryParamsWithTimeout creates a new DeleteGlobalPrivateRegistryParams object
// with the ability to set a timeout on a request.
func NewDeleteGlobalPrivateRegistryParamsWithTimeout(timeout time.Duration) *DeleteGlobalPrivateRegistryParams {
	return &DeleteGlobalPrivateRegistryParams{
		timeout: timeout,
	}
}

// NewDeleteGlobalPrivateRegistryParamsWithContext creates a new DeleteGlobalPrivateRegistryParams object
// with the ability to set a context for a request.
func NewDeleteGlobalPrivateRegistryParamsWithContext(ctx context.Context) *DeleteGlobalPrivateRegistryParams {
	return &DeleteGlobalPrivateRegistryParams{
		Context: ctx,
	}
}

// NewDeleteGlobalPrivateRegistryParamsWithHTTPClient creates a new DeleteGlobalPrivateRegistryParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteGlobalPrivateRegistryParamsWithHTTPClient(client *http.Client) *DeleteGlobalPrivateRegistryParams {
	return &DeleteGlobalPrivateRegistryParams{
		HTTPClient: client,
	}
}

/* DeleteGlobalPrivateRegistryParams contains all the parameters to send to the API endpoint
   for the delete global private registry operation.

   Typically these are written to a http.Request.
*/
type DeleteGlobalPrivateRegistryParams struct {

	/* RegistryPayload.

	   Payload that contains registry data
	*/
	RegistryPayload DeleteGlobalPrivateRegistryBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete global private registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGlobalPrivateRegistryParams) WithDefaults() *DeleteGlobalPrivateRegistryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete global private registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGlobalPrivateRegistryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) WithTimeout(timeout time.Duration) *DeleteGlobalPrivateRegistryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) WithContext(ctx context.Context) *DeleteGlobalPrivateRegistryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) WithHTTPClient(client *http.Client) *DeleteGlobalPrivateRegistryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegistryPayload adds the registryPayload to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) WithRegistryPayload(registryPayload DeleteGlobalPrivateRegistryBody) *DeleteGlobalPrivateRegistryParams {
	o.SetRegistryPayload(registryPayload)
	return o
}

// SetRegistryPayload adds the registryPayload to the delete global private registry params
func (o *DeleteGlobalPrivateRegistryParams) SetRegistryPayload(registryPayload DeleteGlobalPrivateRegistryBody) {
	o.RegistryPayload = registryPayload
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteGlobalPrivateRegistryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.RegistryPayload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
