// Code generated by go-swagger; DO NOT EDIT.

package variables

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetInstanceVariablesParams creates a new GetInstanceVariablesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetInstanceVariablesParams() *GetInstanceVariablesParams {
	return &GetInstanceVariablesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetInstanceVariablesParamsWithTimeout creates a new GetInstanceVariablesParams object
// with the ability to set a timeout on a request.
func NewGetInstanceVariablesParamsWithTimeout(timeout time.Duration) *GetInstanceVariablesParams {
	return &GetInstanceVariablesParams{
		timeout: timeout,
	}
}

// NewGetInstanceVariablesParamsWithContext creates a new GetInstanceVariablesParams object
// with the ability to set a context for a request.
func NewGetInstanceVariablesParamsWithContext(ctx context.Context) *GetInstanceVariablesParams {
	return &GetInstanceVariablesParams{
		Context: ctx,
	}
}

// NewGetInstanceVariablesParamsWithHTTPClient creates a new GetInstanceVariablesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetInstanceVariablesParamsWithHTTPClient(client *http.Client) *GetInstanceVariablesParams {
	return &GetInstanceVariablesParams{
		HTTPClient: client,
	}
}

/* GetInstanceVariablesParams contains all the parameters to send to the API endpoint
   for the get instance variables operation.

   Typically these are written to a http.Request.
*/
type GetInstanceVariablesParams struct {

	/* Instance.

	   target instance
	*/
	Instance string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get instance variables params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetInstanceVariablesParams) WithDefaults() *GetInstanceVariablesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get instance variables params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetInstanceVariablesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get instance variables params
func (o *GetInstanceVariablesParams) WithTimeout(timeout time.Duration) *GetInstanceVariablesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get instance variables params
func (o *GetInstanceVariablesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get instance variables params
func (o *GetInstanceVariablesParams) WithContext(ctx context.Context) *GetInstanceVariablesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get instance variables params
func (o *GetInstanceVariablesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get instance variables params
func (o *GetInstanceVariablesParams) WithHTTPClient(client *http.Client) *GetInstanceVariablesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get instance variables params
func (o *GetInstanceVariablesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInstance adds the instance to the get instance variables params
func (o *GetInstanceVariablesParams) WithInstance(instance string) *GetInstanceVariablesParams {
	o.SetInstance(instance)
	return o
}

// SetInstance adds the instance to the get instance variables params
func (o *GetInstanceVariablesParams) SetInstance(instance string) {
	o.Instance = instance
}

// WithNamespace adds the namespace to the get instance variables params
func (o *GetInstanceVariablesParams) WithNamespace(namespace string) *GetInstanceVariablesParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the get instance variables params
func (o *GetInstanceVariablesParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WriteToRequest writes these params to a swagger request
func (o *GetInstanceVariablesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param instance
	if err := r.SetPathParam("instance", o.Instance); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
