// Code generated by go-swagger; DO NOT EDIT.

package workflow_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetWorkflowServiceParams creates a new GetWorkflowServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetWorkflowServiceParams() *GetWorkflowServiceParams {
	return &GetWorkflowServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetWorkflowServiceParamsWithTimeout creates a new GetWorkflowServiceParams object
// with the ability to set a timeout on a request.
func NewGetWorkflowServiceParamsWithTimeout(timeout time.Duration) *GetWorkflowServiceParams {
	return &GetWorkflowServiceParams{
		timeout: timeout,
	}
}

// NewGetWorkflowServiceParamsWithContext creates a new GetWorkflowServiceParams object
// with the ability to set a context for a request.
func NewGetWorkflowServiceParamsWithContext(ctx context.Context) *GetWorkflowServiceParams {
	return &GetWorkflowServiceParams{
		Context: ctx,
	}
}

// NewGetWorkflowServiceParamsWithHTTPClient creates a new GetWorkflowServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetWorkflowServiceParamsWithHTTPClient(client *http.Client) *GetWorkflowServiceParams {
	return &GetWorkflowServiceParams{
		HTTPClient: client,
	}
}

/* GetWorkflowServiceParams contains all the parameters to send to the API endpoint
   for the get workflow service operation.

   Typically these are written to a http.Request.
*/
type GetWorkflowServiceParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Svn.

	   target service name
	*/
	Svn string

	/* Version.

	   target service version
	*/
	Version string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get workflow service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetWorkflowServiceParams) WithDefaults() *GetWorkflowServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get workflow service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetWorkflowServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get workflow service params
func (o *GetWorkflowServiceParams) WithTimeout(timeout time.Duration) *GetWorkflowServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get workflow service params
func (o *GetWorkflowServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get workflow service params
func (o *GetWorkflowServiceParams) WithContext(ctx context.Context) *GetWorkflowServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get workflow service params
func (o *GetWorkflowServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get workflow service params
func (o *GetWorkflowServiceParams) WithHTTPClient(client *http.Client) *GetWorkflowServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get workflow service params
func (o *GetWorkflowServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the get workflow service params
func (o *GetWorkflowServiceParams) WithNamespace(namespace string) *GetWorkflowServiceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the get workflow service params
func (o *GetWorkflowServiceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithSvn adds the svn to the get workflow service params
func (o *GetWorkflowServiceParams) WithSvn(svn string) *GetWorkflowServiceParams {
	o.SetSvn(svn)
	return o
}

// SetSvn adds the svn to the get workflow service params
func (o *GetWorkflowServiceParams) SetSvn(svn string) {
	o.Svn = svn
}

// WithVersion adds the version to the get workflow service params
func (o *GetWorkflowServiceParams) WithVersion(version string) *GetWorkflowServiceParams {
	o.SetVersion(version)
	return o
}

// SetVersion adds the version to the get workflow service params
func (o *GetWorkflowServiceParams) SetVersion(version string) {
	o.Version = version
}

// WithWorkflow adds the workflow to the get workflow service params
func (o *GetWorkflowServiceParams) WithWorkflow(workflow string) *GetWorkflowServiceParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the get workflow service params
func (o *GetWorkflowServiceParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *GetWorkflowServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// query param svn
	qrSvn := o.Svn
	qSvn := qrSvn
	if qSvn != "" {

		if err := r.SetQueryParam("svn", qSvn); err != nil {
			return err
		}
	}

	// query param version
	qrVersion := o.Version
	qVersion := qrVersion
	if qVersion != "" {

		if err := r.SetQueryParam("version", qVersion); err != nil {
			return err
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
