// Code generated by go-swagger; DO NOT EDIT.

package workflows

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpdateWorkflowParams creates a new UpdateWorkflowParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateWorkflowParams() *UpdateWorkflowParams {
	return &UpdateWorkflowParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateWorkflowParamsWithTimeout creates a new UpdateWorkflowParams object
// with the ability to set a timeout on a request.
func NewUpdateWorkflowParamsWithTimeout(timeout time.Duration) *UpdateWorkflowParams {
	return &UpdateWorkflowParams{
		timeout: timeout,
	}
}

// NewUpdateWorkflowParamsWithContext creates a new UpdateWorkflowParams object
// with the ability to set a context for a request.
func NewUpdateWorkflowParamsWithContext(ctx context.Context) *UpdateWorkflowParams {
	return &UpdateWorkflowParams{
		Context: ctx,
	}
}

// NewUpdateWorkflowParamsWithHTTPClient creates a new UpdateWorkflowParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateWorkflowParamsWithHTTPClient(client *http.Client) *UpdateWorkflowParams {
	return &UpdateWorkflowParams{
		HTTPClient: client,
	}
}

/* UpdateWorkflowParams contains all the parameters to send to the API endpoint
   for the update workflow operation.

   Typically these are written to a http.Request.
*/
type UpdateWorkflowParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	/* WorkflowData.

	   Payload that contains the updated direktiv workflow yaml.
	*/
	WorkflowData string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update workflow params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateWorkflowParams) WithDefaults() *UpdateWorkflowParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update workflow params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateWorkflowParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update workflow params
func (o *UpdateWorkflowParams) WithTimeout(timeout time.Duration) *UpdateWorkflowParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update workflow params
func (o *UpdateWorkflowParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update workflow params
func (o *UpdateWorkflowParams) WithContext(ctx context.Context) *UpdateWorkflowParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update workflow params
func (o *UpdateWorkflowParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update workflow params
func (o *UpdateWorkflowParams) WithHTTPClient(client *http.Client) *UpdateWorkflowParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update workflow params
func (o *UpdateWorkflowParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the update workflow params
func (o *UpdateWorkflowParams) WithNamespace(namespace string) *UpdateWorkflowParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the update workflow params
func (o *UpdateWorkflowParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithWorkflow adds the workflow to the update workflow params
func (o *UpdateWorkflowParams) WithWorkflow(workflow string) *UpdateWorkflowParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the update workflow params
func (o *UpdateWorkflowParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WithWorkflowData adds the workflowData to the update workflow params
func (o *UpdateWorkflowParams) WithWorkflowData(workflowData string) *UpdateWorkflowParams {
	o.SetWorkflowData(workflowData)
	return o
}

// SetWorkflowData adds the workflowData to the update workflow params
func (o *UpdateWorkflowParams) SetWorkflowData(workflowData string) {
	o.WorkflowData = workflowData
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateWorkflowParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}
	if err := r.SetBodyParam(o.WorkflowData); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
